////////////////////////////////////////////////////////////////////////////////
// テーブルソートスクリプト (Javascript) Ver.1.01
//   Copyright (C) 2008 せりか/せりか式
////////////////////////////////////////////////////////////////////////////////

/* provided objects/methods
 *   var tablesort (object)
 */

/* How to use
 *   var obj = tablesort.enable( id );
 */

////////////////////////////////////////
tablesort = {
	tables : new Array(),
	enable : function(id){
		var tbl = document.getElementById(id);
		if(!tbl) return false;

		// check table header
		var th = tbl.getElementsByTagName('thead');
		if(!th) return false;
		th = th[0];

		// regist
		var table = tablesort.tables[id] = {
			'asc': 0,
			'table': tbl,
			'thead': th,
			'last': null
		}

		// set event handler
		var headers = th.getElementsByTagName('th');
		for(var i in headers){
			tablesort.addEvent(headers[i], 'click', tablesort.sort);
		}

		return table;
	},
	_getTableId: function (obj){
		var tagname;
		while(obj){
			tagname = obj.tagName || obj.localName;
			if(tagname == 'TABLE')
				return obj.id;
			obj = obj.parentNode;
		}
		return null;
	},
	sort: function(e){
		var elem = e.srcElement || e.target;
		var doc = elem.ownerDocument;

		// get table
		id = tablesort._getTableId(elem);
		var table = tablesort.tables[id];
		if(!table) return false;

		// search sort colomn
		var headers = table['thead'].getElementsByTagName('th');
		var col = -1;
		for(i in headers){
			if(headers[i] === elem)
				col = i;
		}
		if(col == -1) return false;

		// check type
		var type = 'str';
		if(tablesort.hasClassMatch(headers[col], 'num')) type = 'num';

		// compare method
		var comp;
		if(table['last'] == col) table['asc'] = 1 - table['asc'];
		else                     table['asc'] = 0;
		table['last'] = col;
		comp = '_compare_' + type + (table['asc'] ? '_asc' : '_dec');

		var tb = table['table'].getElementsByTagName('tbody');
		if(!tb) return false;
		tb = tb[0];

		// sort
		var trs = tb.getElementsByTagName('tr');
		var td;
		var ary = new Array();
		var cache = new Array();
		for(var i = 0; i < trs.length; i++){
			td = trs[i].getElementsByTagName('td');
			val1 = td[col].innerText || td[col].textContent;
			ary[i] = {'index':i, 'value':val1};
			cache[i] = trs[i];
		}
		while(tb.firstChild)
			tb.removeChild(tb.firstChild);
		ary.sort(tablesort[comp]);
		for(var i in ary){
			if(i % 2){
				tablesort.delClass(cache[ary[i].index], 'odd');
				tablesort.addClass(cache[ary[i].index], 'even');
			}else{
				tablesort.delClass(cache[ary[i].index], 'even');
				tablesort.addClass(cache[ary[i].index], 'odd');
			}
			tb.appendChild(cache[ary[i].index]);
		}
	},

	// compare methods
	_compare_str_asc: function(val1, val2){
		return (val2.value.toLowerCase() == val1.value.toLowerCase()) ? 0 : (val2.value.toLowerCase() < val1.value.toLowerCase()) ? -1 : 1;
	},
	_compare_str_dec: function(val1, val2){
		return (val1.value.toLowerCase() == val2.value.toLowerCase()) ? 0 : (val1.value.toLowerCase() < val2.value.toLowerCase()) ? -1 : 1;
	},
	_compare_num_asc: function(val1, val2){
		return (parseFloat(val2.value) - parseFloat(val1.value));
	},
	_compare_num_dec: function(val1, val2){
		return (parseFloat(val1.value) - parseFloat(val2.value));
	},

	////////////////////////////////////
	// some useful methods
	addEvent : function (obj, name, func) {
		if(obj == undefined || name == '' || func == undefined) return false;

		if(obj.addEventListener) obj.addEventListener(name, func, false);
		else if(obj.attachEvent) obj.attachEvent('on'+name, func);
		else return false;// setAttribute('on'+name, func);

		return true;
	},
	delEvent : function (obj, name, func) {
		if(obj == undefined || name == '' || func == undefined) return false;

		if(obj.removeEventListener) obj.removeEventListener(name, func, false);
		else if(obj.detachEvent)    obj.detachEvent('on'+name, func);
		else return false;// setAttribute('on'+name, '');

		return true;
	},
	hasClassMatch : function (obj, name) {
		if(!obj) return false;

		var re = new RegExp(name, "i");
		if(obj.className.match(re))
			return true;
		return false;
	},
	hasClass : function (obj, name) {
		if(!obj) return false;

		var classes = obj.className.split(' ');
		var found = false;
		for(i in classes){
			if(classes[i] == name){
				found = true;
				break;
			}
		}

		return found;
	},
	addClass : function (obj, name) {
		if(!obj) return false;

		var classes = obj.className.split(' ');
		var found = false;
		for(i in classes){
			if(classes[i] == name){
				found = true;
				break;
			}
		}
		if(!found)
			classes.push(name);

		obj.className = classes.join(' ');
		return true;
	},
	delClass : function (obj, name) {
		if(!obj) return false;

		var classes = obj.className.split(' ');
		for(i in classes){
			if(classes[i] == name){
				classes[i] = '';
				break;
			}
		}

		obj.className = classes.join(' ');
		return true;
	}
}

